Index: /palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90	(revision 1320)
@@ -20,12 +20,13 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
-!
-! 1318 2014-03-17 13:35:16Z raasch
-! module interfaces removed
 !
 ! 1036 2012-10-22 13:43:42Z raasch
@@ -41,16 +42,37 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE cloud_parameters
-    USE constants
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
-    USE particle_attributes
+    USE arrays_3d,                                                             &
+        ONLY:  ql, ql_v, ql_vp
+
+    USE cloud_parameters,                                                      &
+        ONLY:  rho_l
+
+    USE constants,                                                             &
+        ONLY:  pi
+
+    USE control_parameters,                                                    &
+        ONLY:  dz, message_string, rho_surface
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxr, nyn, nys, nzb, nzt
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  particles, prt_count, prt_start_index
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, n, psi
+    INTEGER(iwp) ::  i   !:
+    INTEGER(iwp) ::  j   !:
+    INTEGER(iwp) ::  k   !:
+    INTEGER(iwp) ::  n   !:
+    INTEGER(iwp) ::  psi !:
 
 
Index: /palm/trunk/SOURCE/lpm_collision_kernels.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 1320)
@@ -20,12 +20,14 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
-!
-! 1318 2014-03-17 13:35:16Z raasch
-! module interfaces removed
 !
 ! 1092 2013-02-02 11:24:22Z raasch
@@ -62,9 +64,4 @@
 ! routine renamed from wang_kernel to lpm_collision_kernels,
 ! turbulence_effects on collision replaced by wang_kernel
-!
-! 799 2011-12-21 17:48:03Z franke
-! speed optimizations and formatting
-! Bugfix: iq=1 is not allowed (routine effic) 
-! Bugfix: replaced stop by ec=0.0 in case of very small ec (routine effic) 
 !
 ! 790 2011-11-29 03:11:20Z raasch
@@ -86,8 +83,12 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE cloud_parameters
-    USE constants
-    USE particle_attributes
+    USE constants,                                                             &
+        ONLY:  pi
+        
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  collision_kernel, dissipation_classes, particles, radius_classes
+
     USE pegrid
 
@@ -100,9 +101,22 @@
             rclass_lbound, rclass_ubound, recalculate_kernel
 
-    REAL ::  epsilon, eps2, rclass_lbound, rclass_ubound, urms, urms2
-
-    REAL, DIMENSION(:),   ALLOCATABLE ::  epsclass, radclass, winf
-    REAL, DIMENSION(:,:), ALLOCATABLE ::  ec, ecf, gck, hkernel, hwratio
-    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  ckernel
+    REAL(wp) ::  epsilon       !:
+    REAL(wp) ::  eps2          !:
+    REAL(wp) ::  rclass_lbound !:
+    REAL(wp) ::  rclass_ubound !:
+    REAL(wp) ::  urms          !:
+    REAL(wp) ::  urms2         !:
+
+    REAL(wp), DIMENSION(:),   ALLOCATABLE ::  epsclass !:
+    REAL(wp), DIMENSION(:),   ALLOCATABLE ::  radclass !:
+    REAL(wp), DIMENSION(:),   ALLOCATABLE ::  winf     !:
+    
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ec       !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ecf      !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  gck      !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  hkernel  !:
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  hwratio  !:
+    
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE   ::  ckernel !:
 
     SAVE
@@ -134,5 +148,7 @@
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
+       INTEGER(iwp) ::  i !:
+       INTEGER(iwp) ::  j !:
+       INTEGER(iwp) ::  k !:
 
 
@@ -262,14 +278,19 @@
     SUBROUTINE recalculate_kernel( i1, j1, k1 )
 
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
-       USE cpulog
-       USE indices
-       USE particle_attributes
+       USE arrays_3d,                                                          &
+           ONLY:  diss
+
+       USE particle_attributes,                                                &
+           ONLY:  prt_count, prt_start_index, radius_classes, wang_kernel
 
        IMPLICIT NONE
 
-       INTEGER ::  i, i1, j, j1, k1, pend, pstart
+       INTEGER(iwp) ::  i      !:
+       INTEGER(iwp) ::  i1     !:
+       INTEGER(iwp) ::  j      !:
+       INTEGER(iwp) ::  j1     !:
+       INTEGER(iwp) ::  k1     !:
+       INTEGER(iwp) ::  pend   !:
+       INTEGER(iwp) ::  pstart !:
 
 
@@ -340,24 +361,64 @@
     SUBROUTINE turbsd
 
-       USE constants
-       USE cloud_parameters
-       USE particle_attributes
-       USE arrays_3d
-       USE control_parameters
+       USE control_parameters,                                                 &
+           ONLY:  g, molecular_viscosity
+    
+       USE particle_attributes,                                                &
+           ONLY:  radius_classes
 
        IMPLICIT NONE
-
-       INTEGER ::  i, j
-
-       LOGICAL, SAVE ::  first = .TRUE.
-
-       REAL ::  ao, ao_gr, bbb, be, b1, b2, ccc, c1, c1_gr, c2, d1, d2, eta, &
-                e1, e2, fao_gr, fr, grfin, lambda, lambda_re, lf, rc, rrp,   &
-                sst, tauk, tl, t2, tt, t1, vk, vrms1xy, vrms2xy, v1, v1v2xy, &
-                v1xysq, v2, v2xysq, wrfin, wrgrav2, wrtur2xy, xx, yy, z
-
-       REAL, DIMENSION(1:radius_classes) ::  st, tau
-
-
+       
+       LOGICAL, SAVE ::  first = .TRUE. !:
+
+       INTEGER(iwp) ::  i     !:
+       INTEGER(iwp) ::  j     !:
+
+       REAL(wp) ::  ao        !:
+       REAL(wp) ::  ao_gr     !:
+       REAL(wp) ::  bbb       !:
+       REAL(wp) ::  be        !:
+       REAL(wp) ::  b1        !:
+       REAL(wp) ::  b2        !:
+       REAL(wp) ::  ccc       !:
+       REAL(wp) ::  c1        !:
+       REAL(wp) ::  c1_gr     !:
+       REAL(wp) ::  c2        !:
+       REAL(wp) ::  d1        !:
+       REAL(wp) ::  d2        !:
+       REAL(wp) ::  eta       !:
+       REAL(wp) ::  e1        !:
+       REAL(wp) ::  e2        !:
+       REAL(wp) ::  fao_gr    !:
+       REAL(wp) ::  fr        !:
+       REAL(wp) ::  grfin     !:
+       REAL(wp) ::  lambda    !:
+       REAL(wp) ::  lambda_re !:
+       REAL(wp) ::  lf        !:
+       REAL(wp) ::  rc        !:
+       REAL(wp) ::  rrp       !:
+       REAL(wp) ::  sst       !:
+       REAL(wp) ::  tauk      !:
+       REAL(wp) ::  tl        !:
+       REAL(wp) ::  t2        !:
+       REAL(wp) ::  tt        !:
+       REAL(wp) ::  t1        !:
+       REAL(wp) ::  vk        !:
+       REAL(wp) ::  vrms1xy   !:
+       REAL(wp) ::  vrms2xy   !:
+       REAL(wp) ::  v1        !:
+       REAL(wp) ::  v1v2xy    !:
+       REAL(wp) ::  v1xysq    !:
+       REAL(wp) ::  v2        !:
+       REAL(wp) ::  v2xysq    !:
+       REAL(wp) ::  wrfin     !:
+       REAL(wp) ::  wrgrav2   !:
+       REAL(wp) ::  wrtur2xy  !:
+       REAL(wp) ::  xx        !:
+       REAL(wp) ::  yy        !:
+       REAL(wp) ::  z         !:
+
+       REAL(wp), DIMENSION(1:radius_classes) ::  st  !:
+       REAL(wp), DIMENSION(1:radius_classes) ::  tau !:
+       
 !
 !--    Initial assignment of constants
@@ -478,9 +539,13 @@
 ! phi_w as a function
 !------------------------------------------------------------------------------!
-    REAL FUNCTION phi_w( a, b, vsett, tau0 )
+    REAL(wp) FUNCTION phi_w( a, b, vsett, tau0 )
 
        IMPLICIT NONE
 
-       REAL ::  a, aa1, b, tau0, vsett
+       REAL(wp) ::  a     !:
+       REAL(wp) ::  aa1   !:
+       REAL(wp) ::  b     !:
+       REAL(wp) ::  tau0  !:
+       REAL(wp) ::  vsett !:
 
        aa1 = 1.0 / tau0 + 1.0 / a + vsett / b
@@ -493,9 +558,20 @@
 ! zhi as a function
 !------------------------------------------------------------------------------!
-    REAL FUNCTION zhi( a, b, vsett1, tau1, vsett2, tau2 )
+    REAL(wp) FUNCTION zhi( a, b, vsett1, tau1, vsett2, tau2 )
 
        IMPLICIT NONE
 
-       REAL ::  a, aa1, aa2, aa3, aa4, aa5, aa6, b, tau1, tau2, vsett1, vsett2
+       REAL(wp) ::  a      !:
+       REAL(wp) ::  aa1    !:
+       REAL(wp) ::  aa2    !:
+       REAL(wp) ::  aa3    !:
+       REAL(wp) ::  aa4    !:
+       REAL(wp) ::  aa5    !:
+       REAL(wp) ::  aa6    !:
+       REAL(wp) ::  b      !:
+       REAL(wp) ::  tau1   !:
+       REAL(wp) ::  tau2   !:
+       REAL(wp) ::  vsett1 !:
+       REAL(wp) ::  vsett2 !:
 
        aa1 = vsett2 / b - 1.0 / tau2 - 1.0 / a
@@ -518,23 +594,39 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE fallg
-
-       USE constants
-       USE cloud_parameters
-       USE particle_attributes
-       USE arrays_3d
-       USE control_parameters
+ 
+       USE cloud_parameters,                                                   &
+           ONLY:  rho_l
+    
+       USE control_parameters,                                                 &
+           ONLY:  g
+
+       USE particle_attributes,                                                &
+           ONLY:  radius_classes
+
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j
-
-       LOGICAL, SAVE ::  first = .TRUE.
-
-       REAL, SAVE ::  cunh, eta, phy, py, rho_a, sigma, stb, stok, xlamb
-
-       REAL ::  bond, x, xrey, y
-
-       REAL, DIMENSION(1:7), SAVE  ::  b
-       REAL, DIMENSION(1:6), SAVE  ::  c
+       INTEGER(iwp) ::  i !:
+       INTEGER(iwp) ::  j !:
+
+       LOGICAL, SAVE ::  first = .TRUE. !:
+
+       REAL(wp), SAVE ::  cunh  !:
+       REAL(wp), SAVE ::  eta   !:
+       REAL(wp), SAVE ::  phy   !:
+       REAL(wp), SAVE ::  py    !:
+       REAL(wp), SAVE ::  rho_a !:
+       REAL(wp), SAVE ::  sigma !:
+       REAL(wp), SAVE ::  stb   !:
+       REAL(wp), SAVE ::  stok  !:
+       REAL(wp), SAVE ::  xlamb !:
+
+       REAL(wp) ::  bond        !:
+       REAL(wp) ::  x           !:
+       REAL(wp) ::  xrey        !:
+       REAL(wp) ::  y           !:
+
+       REAL(wp), DIMENSION(1:7), SAVE  ::  b !:
+       REAL(wp), DIMENSION(1:6), SAVE  ::  c !:
 
 !
@@ -617,23 +709,31 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE effic
-
-       USE arrays_3d
-       USE cloud_parameters
-       USE constants
-       USE particle_attributes
+ 
+       USE particle_attributes,                                                &
+           ONLY:  radius_classes
 
        IMPLICIT NONE
 
-       INTEGER ::  i, iq, ir, j, k
-
-       INTEGER, DIMENSION(:), ALLOCATABLE ::  ira
-
-       LOGICAL, SAVE ::  first = .TRUE.
-
-       REAL ::  ek, particle_radius, pp, qq, rq
-
-       REAL, DIMENSION(1:21), SAVE ::  rat
-       REAL, DIMENSION(1:15), SAVE ::  r0
-       REAL, DIMENSION(1:15,1:21), SAVE ::  ecoll
+       INTEGER(iwp) ::  i  !:
+       INTEGER(iwp) ::  iq !:
+       INTEGER(iwp) ::  ir !:
+       INTEGER(iwp) ::  j  !:
+       INTEGER(iwp) ::  k  !:
+
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ira !:
+
+       LOGICAL, SAVE ::  first = .TRUE. !:
+
+       REAL(wp) ::  ek              !:
+       REAL(wp) ::  particle_radius !:
+       REAL(wp) ::  pp              !:
+       REAL(wp) ::  qq              !:
+       REAL(wp) ::  rq              !:
+
+       REAL(wp), DIMENSION(1:21), SAVE ::  rat        !:
+       
+       REAL(wp), DIMENSION(1:15), SAVE ::  r0         !:
+       
+       REAL(wp), DIMENSION(1:15,1:21), SAVE ::  ecoll !:
 
 !
@@ -754,22 +854,34 @@
     SUBROUTINE turb_enhance_eff
 
-       USE constants
-       USE cloud_parameters
-       USE particle_attributes
-       USE arrays_3d
+       USE particle_attributes,                                                &
+           ONLY:  radius_classes
 
        IMPLICIT NONE
 
-       INTEGER :: i, iq, ir, j, k, kk
-
-       INTEGER, DIMENSION(:), ALLOCATABLE ::  ira
-
-       REAL ::  particle_radius, pp, qq, rq, y1, y2, y3
-
-       LOGICAL, SAVE ::  first = .TRUE.
-
-       REAL, DIMENSION(1:11), SAVE ::  rat
-       REAL, DIMENSION(1:7), SAVE  ::  r0
-       REAL, DIMENSION(1:7,1:11), SAVE ::  ecoll_100, ecoll_400
+       INTEGER(iwp) :: i  !:
+       INTEGER(iwp) :: iq !:
+       INTEGER(iwp) :: ir !:
+       INTEGER(iwp) :: j  !:
+       INTEGER(iwp) :: k  !:
+       INTEGER(iwp) :: kk !:
+
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ira !:
+       
+       LOGICAL, SAVE ::  first = .TRUE. !:
+
+       REAL(wp) ::  particle_radius !:
+       REAL(wp) ::  pp              !:
+       REAL(wp) ::  qq              !:
+       REAL(wp) ::  rq              !:
+       REAL(wp) ::  y1              !:
+       REAL(wp) ::  y2              !:
+       REAL(wp) ::  y3              !:
+
+       REAL(wp), DIMENSION(1:11), SAVE ::  rat           !:
+       
+       REAL(wp), DIMENSION(1:7), SAVE  ::  r0            !:
+       
+       REAL(wp), DIMENSION(1:7,1:11), SAVE ::  ecoll_100 !:
+       REAL(wp), DIMENSION(1:7,1:11), SAVE ::  ecoll_400 !:
 
 !
@@ -898,14 +1010,30 @@
        IMPLICIT NONE
 
-       INTEGER       ::  i, j, k
-
-       LOGICAL, SAVE ::  first = .TRUE.
-
-       REAL          ::  aa, bb, cc, dd, dx, dy, e, gg, mean_r, mean_rm, r, &
-                         rm, x, y
-
-       REAL, DIMENSION(1:9), SAVE      ::  collected_r = 0.0
-       REAL, DIMENSION(1:19), SAVE     ::  collector_r = 0.0
-       REAL, DIMENSION(1:9,1:19), SAVE ::  ef = 0.0
+       INTEGER(iwp)  ::  i !:
+       INTEGER(iwp)  ::  j !:
+       INTEGER(iwp)  ::  k !:
+
+       LOGICAL, SAVE ::  first = .TRUE. !:
+
+       REAL(wp)      ::  aa      !:
+       REAL(wp)      ::  bb      !:
+       REAL(wp)      ::  cc      !:
+       REAL(wp)      ::  dd      !:
+       REAL(wp)      ::  dx      !:
+       REAL(wp)      ::  dy      !:
+       REAL(wp)      ::  e       !:
+       REAL(wp)      ::  gg      !:
+       REAL(wp)      ::  mean_r  !:
+       REAL(wp)      ::  mean_rm !:
+       REAL(wp)      ::  r       !:
+       REAL(wp)      ::  rm      !:
+       REAL(wp)      ::  x       !:
+       REAL(wp)      ::  y       !:
+ 
+       REAL(wp), DIMENSION(1:9), SAVE      ::  collected_r = 0.0 !:
+       
+       REAL(wp), DIMENSION(1:19), SAVE     ::  collector_r = 0.0 !:
+       
+       REAL(wp), DIMENSION(1:9,1:19), SAVE ::  ef = 0.0          !:
 
        mean_rm = mean_r * 1.0E06
Index: /palm/trunk/SOURCE/lpm_data_output_particles.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_data_output_particles.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_data_output_particles.f90	(revision 1320)
@@ -20,13 +20,10 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! revision history before 2012 removed,
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
-!
-! 1318 2014-03-17 13:35:16Z raasch
-! module interfaces removed
-!
 !
 ! 1036 2012-10-22 13:43:42Z raasch
@@ -43,8 +40,16 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE cpulog
+    USE control_parameters,                                                    &
+        ONLY:  netcdf_output, prt_time_count, simulated_time
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
     USE netcdf_control
-    USE particle_attributes
+
+    USE particle_attributes,                                                   &
+        ONLY:  maximum_number_of_particles, maximum_number_of_tailpoints,      &
+               maximum_number_of_tails, number_of_particles, number_of_tails,  &
+               particles, particle_tail_coordinates
 
     IMPLICIT NONE
@@ -64,5 +69,5 @@
                   number_of_tails
     IF ( maximum_number_of_tails > 0 )  THEN
-       WRITE ( 85 )  particle_tail_coordinates
+       WRITE ( 85 )  particle_tail_coordinates, prt_time_count
     ENDIF
 
Index: /palm/trunk/SOURCE/lpm_droplet_collision.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_droplet_collision.f90	(revision 1320)
@@ -20,12 +20,14 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
-!
-! 1318 2014-03-17 13:35:16Z raasch
-! module interfaces removed
 !
 ! 1092 2013-02-02 11:24:22Z raasch
@@ -67,26 +69,90 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE cloud_parameters
-    USE constants
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
-    USE lpm_collision_kernels_mod
-    USE particle_attributes
+    USE arrays_3d,                                                             &
+        ONLY:  diss, ql, ql_v, ql_vp, u, v, w, zu, zw
+
+    USE cloud_parameters,                                                      &
+        ONLY:  effective_coll_efficiency
+
+    USE constants,                                                             &
+        ONLY:  pi
+
+    USE control_parameters,                                                    &
+        ONLY:  dt_3d, message_string, u_gtrans, v_gtrans, dz
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx, dx, ddy, dy
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxr, nyn, nys, nzb, nzt 
+
+    USE kinds
+
+    USE lpm_collision_kernels_mod,                                             &
+        ONLY:  ckernel, collision_efficiency_rogers, recalculate_kernel
+
+    USE particle_attributes,                                                   &
+        ONLY:  deleted_particles, dissipation_classes, hall_kernel,            &
+               palm_kernel, particles, particle_mask, particle_type,           &
+               prt_count, prt_start_index, use_kernel_tables, wang_kernel
 
     IMPLICIT NONE
 
-    INTEGER ::  eclass, i, ii, inc, is, j, jj, js, k, kk, n, pse, psi, rclass_l, &
-                rclass_s
-
-    REAL ::  aa, bb, cc, dd, delta_r, delta_v, gg, epsilon, mean_r, ql_int,    &
-             ql_int_l, ql_int_u, u_int, u_int_l, u_int_u, v_int, v_int_l,      &
-             v_int_u, w_int, w_int_l, w_int_u, sl_r3, sl_r4, x, y, sum1, sum2, &
-             sum3, r3, ddV
-
-    TYPE(particle_type) ::  tmp_particle
-    REAL, DIMENSION(:), ALLOCATABLE :: rad, weight
+    INTEGER(iwp) ::  eclass   !:
+    INTEGER(iwp) ::  i        !:
+    INTEGER(iwp) ::  ii       !:
+    INTEGER(iwp) ::  inc      !:
+    INTEGER(iwp) ::  is       !:
+    INTEGER(iwp) ::  j        !:
+    INTEGER(iwp) ::  jj       !:
+    INTEGER(iwp) ::  js       !:
+    INTEGER(iwp) ::  k        !:
+    INTEGER(iwp) ::  kk       !:
+    INTEGER(iwp) ::  n        !:
+    INTEGER(iwp) ::  pse      !:
+    INTEGER(iwp) ::  psi      !:
+    INTEGER(iwp) ::  rclass_l !:
+    INTEGER(iwp) ::  rclass_s !:
+
+    REAL(wp) ::  aa       !:
+    REAL(wp) ::  bb       !:
+    REAL(wp) ::  cc       !:
+    REAL(wp) ::  dd       !:
+    REAL(wp) ::  ddV      !:
+    REAL(wp) ::  delta_r  !:
+    REAL(wp) ::  delta_v  !:
+    REAL(wp) ::  epsilon  !:
+    REAL(wp) ::  gg       !:
+    REAL(wp) ::  mean_r   !:
+    REAL(wp) ::  ql_int   !:
+    REAL(wp) ::  ql_int_l !:
+    REAL(wp) ::  ql_int_u !:
+    REAL(wp) ::  r3       !:
+    REAL(wp) ::  sl_r3    !:
+    REAL(wp) ::  sl_r4    !:
+    REAL(wp) ::  sum1     !:
+    REAL(wp) ::  sum2     !:
+    REAL(wp) ::  sum3     !:
+    REAL(wp) ::  u_int    !:
+    REAL(wp) ::  u_int_l  !:
+    REAL(wp) ::  u_int_u  !:
+    REAL(wp) ::  v_int    !:
+    REAL(wp) ::  v_int_l  !:
+    REAL(wp) ::  v_int_u  !:
+    REAL(wp) ::  w_int    !:
+    REAL(wp) ::  w_int_l  !:
+    REAL(wp) ::  w_int_u  !:
+    REAL(wp) ::  x        !:
+    REAL(wp) ::  y        !:
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rad    !:
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  weight !:
+
+
+    TYPE(particle_type) ::  tmp_particle           !:
+
 
 
Index: /palm/trunk/SOURCE/lpm_droplet_condensation.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_droplet_condensation.f90	(revision 1319)
+++ /palm/trunk/SOURCE/lpm_droplet_condensation.f90	(revision 1320)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -61,37 +65,113 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE cloud_parameters
-    USE constants
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE lpm_collision_kernels_mod
-    USE particle_attributes
+    USE arrays_3d,                                                             &
+        ONLY:  hyp, pt, q,  ql_c, ql_v, zu
+
+    USE cloud_parameters,                                                      &
+        ONLY:  bfactor, curvature_solution_effects, diff_coeff_l,              &
+               eps_ros, l_d_rv, l_v, rho_l,  r_v, thermal_conductivity_l
+
+    USE constants,                                                             &
+        ONLY:  pi
+
+    USE control_parameters,                                                    &
+        ONLY:  atmos_ocean_sign, dt_3d, dz, message_string,                    &
+               molecular_viscosity, rho_surface
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, ddx, dy, ddy
+
+    USE lpm_collision_kernels_mod,                                             &
+        ONLY:  rclass_lbound, rclass_ubound
+
+    USE kinds
+
+    USE particle_attributes,                                                   &
+        ONLY:  hall_kernel, number_of_particles, offset_ocean_nzt,             &
+               offset_ocean_nzt_m1, particles, radius_classes,                 &
+               use_kernel_tables, wang_kernel
+
 
     IMPLICIT NONE
 
-    INTEGER ::  i, internal_timestep_count, j, jtry, k, n, ros_count
-
-    INTEGER, PARAMETER ::  maxtry = 40
-
-    LOGICAL ::  repeat
-
-    REAL ::  aa, afactor, arg, bb, cc, dd, ddenom, delta_r, drdt, drdt_ini,    &
-             dt_ros, dt_ros_next, dt_ros_sum, dt_ros_sum_ini, d2rdtdr, errmax, &
-             err_ros, g1, g2, g3, g4, e_a, e_s, gg, new_r, p_int, pt_int,      &
-             pt_int_l, pt_int_u, q_int, q_int_l, q_int_u, r_ros, r_ros_ini,    &
-             sigma, t_int, x, y, re_p
-
-!
+    INTEGER(iwp) :: i                          !:
+    INTEGER(iwp) :: internal_timestep_count    !:
+    INTEGER(iwp) :: j                          !:
+    INTEGER(iwp) :: jtry                       !:
+    INTEGER(iwp) :: k                          !:
+    INTEGER(iwp) :: n                          !:
+    INTEGER(iwp) :: ros_count                  !:
+ 
+    INTEGER(iwp), PARAMETER ::  maxtry = 40    !:
+
+    LOGICAL ::  repeat                         !:
+
+    REAL(wp) ::  aa                            !:
+    REAL(wp) ::  afactor                       !:
+    REAL(wp) ::  arg                           !:
+    REAL(wp) ::  bb                            !:
+    REAL(wp) ::  cc                            !:
+    REAL(wp) ::  dd                            !:
+    REAL(wp) ::  ddenom                        !:
+    REAL(wp) ::  delta_r                       !:
+    REAL(wp) ::  drdt                          !:
+    REAL(wp) ::  drdt_ini                      !:
+    REAL(wp) ::  dt_ros                        !:
+    REAL(wp) ::  dt_ros_next                   !:
+    REAL(wp) ::  dt_ros_sum                    !:
+    REAL(wp) ::  dt_ros_sum_ini                !:
+    REAL(wp) ::  d2rdtdr                       !:
+    REAL(wp) ::  errmax                        !:
+    REAL(wp) ::  err_ros                       !:
+    REAL(wp) ::  g1                            !:
+    REAL(wp) ::  g2                            !:
+    REAL(wp) ::  g3                            !:
+    REAL(wp) ::  g4                            !:
+    REAL(wp) ::  e_a                           !:
+    REAL(wp) ::  e_s                           !:
+    REAL(wp) ::  gg                            !:
+    REAL(wp) ::  new_r                         !:
+    REAL(wp) ::  p_int                         !:
+    REAL(wp) ::  pt_int                        !:
+    REAL(wp) ::  pt_int_l                      !:
+    REAL(wp) ::  pt_int_u                      !:
+    REAL(wp) ::  q_int                         !:
+    REAL(wp) ::  q_int_l                       !:
+    REAL(wp) ::  q_int_u                       !:
+    REAL(wp) ::  r_ros                         !:
+    REAL(wp) ::  r_ros_ini                     !:
+    REAL(wp) ::  sigma                         !:
+    REAL(wp) ::  t_int                         !:
+    REAL(wp) ::  x                             !:
+    REAL(wp) ::  y                             !: 
+    REAL(wp) ::  re_p                          !:
+ 
 !-- Parameters for Rosenbrock method
-    REAL, PARAMETER ::  a21 = 2.0, a31 = 48.0/25.0, a32 = 6.0/25.0,        &
-                        b1 = 19.0/9.0, b2 = 0.5, b3 = 25.0/108.0,          &
-                        b4 = 125.0/108.0, c21 = -8.0, c31 = 372.0/25.0,    &
-                        c32 = 12.0/5.0, c41 = -112.0/125.0,                &
-                        c42 = -54.0/125.0, c43 = -2.0/5.0,                 &
-                        errcon = 0.1296, e1 = 17.0/54.0, e2 = 7.0/36.0,    &
-                        e3 = 0.0, e4 = 125.0/108.0, gam = 0.5, grow = 1.5, &
-                        pgrow = -0.25, pshrnk = -1.0/3.0, shrnk = 0.5
+    REAL(wp), PARAMETER ::  a21 = 2.0          !:
+    REAL(wp), PARAMETER ::  a31 = 48.0/25.0    !:
+    REAL(wp), PARAMETER ::  a32 = 6.0/25.0     !:
+    REAL(wp), PARAMETER ::  b1 = 19.0/9.0      !:
+    REAL(wp), PARAMETER ::  b2 = 0.5           !:
+    REAL(wp), PARAMETER ::  b3 = 25.0/108.0    !:
+    REAL(wp), PARAMETER ::  b4 = 125.0/108.0   !:
+    REAL(wp), PARAMETER ::  c21 = -8.0         !:
+    REAL(wp), PARAMETER ::  c31 = 372.0/25.0   !:
+    REAL(wp), PARAMETER ::  c32 = 12.0/5.0     !:
+    REAL(wp), PARAMETER ::  c41 = -112.0/125.0 !:
+    REAL(wp), PARAMETER ::  c42 = -54.0/125.0  !:
+    REAL(wp), PARAMETER ::  c43 = -2.0/5.0     !:
+    REAL(wp), PARAMETER ::  errcon = 0.1296    !:
+    REAL(wp), PARAMETER ::  e1 = 17.0/54.0     !:
+    REAL(wp), PARAMETER ::  e2 = 7.0/36.0      !:
+    REAL(wp), PARAMETER ::  e3 = 0.0           !:
+    REAL(wp), PARAMETER ::  e4 = 125.0/108.0   !:
+    REAL(wp), PARAMETER ::  gam = 0.5          !:
+    REAL(wp), PARAMETER ::  grow = 1.5         !:
+    REAL(wp), PARAMETER ::  pgrow = -0.25      !:
+    REAL(wp), PARAMETER ::  pshrnk = -1.0/3.0  !:
+    REAL(wp), PARAMETER ::  shrnk = 0.5        !:
+
 
 
